# flopc::MP_expression_base Class Reference
[Internal (private) interface.]

The base class for all expressions. More...

`#include <MP_expression.hpp>`

Inheritance diagram for flopc::MP_expression_base:
[legend]

List of all members.

## Public Member Functions
| MP_expression_base ()
virtual double | level () const =0
virtual void | generate (const MP_domain &domain, std::vector< Constant > multiplicators, GenerateFunctor &f, double m) const =0
virtual void | insertVariables (std::set< MP_variable * > &v) const =0
virtual | ~MP_expression_base ()
## Private Attributes
int | count
## Friends
class | MP_expression
class | Handle< MP_expression_base * >

## Detailed Description

The base class for all expressions.

Note:
  FOR INTERNAL USE: This is not normally used directly by the calling code.

Definition at line 93 of file MP_expression.hpp.

## Constructor & Destructor Documentation

flopc::MP_expression_base::MP_expression_base | ( |  | ) | `[inline]`

Definition at line 99 of file MP_expression.hpp.

virtual flopc::MP_expression_base::~MP_expression_base | ( |  | ) | `[inline, virtual]`

Definition at line 108 of file MP_expression.hpp.

## Member Function Documentation

virtual double flopc::MP_expression_base::level | ( |  | ) | const`[pure virtual]`

Implemented in flopc::VariableRef.

virtual void flopc::MP_expression_base::generate | ( | const MP_domain & | domain,
|  | std::vector< Constant > | multiplicators,
|  | GenerateFunctor & | f,
|  | double | m |
| ) |  |  | const`[pure virtual]`

Implemented in flopc::VariableRef.

virtual void flopc::MP_expression_base::insertVariables | ( | std::set< MP_variable * > & | v | ) | const`[pure virtual]`

Implemented in flopc::Expression_operator, and flopc::VariableRef.

## Friends And Related Function Documentation

friend class MP_expression`[friend]`

Definition at line 94 of file MP_expression.hpp.

friend class Handle< MP_expression_base * >`[friend]`

Definition at line 95 of file MP_expression.hpp.

## Member Data Documentation

int flopc::MP_expression_base::count`[private]`

Definition at line 97 of file MP_expression.hpp.

The documentation for this class was generated from the following file:

- /home/coin/svn-release/Smi-0.93.1/FlopCpp/src/MP_expression.hpp